# -----------------------------------------------------------------------------
# $Id: Reload.pm,v 1.4 2004/07/08 15:13:14 topia Exp $
# -----------------------------------------------------------------------------
package System::Reload;
use strict;
use warnings;
use base qw(Module);
use ReloadTrigger;
use Timer;
use Configuration;

sub new {
    my $class = shift;
    my $this = $class->SUPER::new(@_);

    if (!defined $this->config->conf_reloaded_notify ||
	    $this->config->conf_reloaded_notify) {
	$this->{conf_hook} = Configuration::Hook->new(
	    sub {
		my ($hook) = shift;
		RunLoop->shared_loop->notify_msg("Reloaded configuration file.");
	    })->install('reloaded');
    }
    return $this;
}

sub destruct {
    my $this = shift;

    $this->{conf_hook}->uninstall if defined $this->{conf_hook};
    $this->{conf_hook} = undef;
}

sub message_arrived {
    my ($this,$msg,$sender) = @_;
    # 饤Ȥȯ
    if ($sender->isa('IrcIO::Client')) {
	# ޥ̾ϰפƤ뤫
	if ($msg->command eq uc($this->config->command)) {
	    # ɬפʤɤ¹ԡ
	    Timer->new(
		After => 0,
		Code => sub {
		    ReloadTrigger->reload_conf_if_updated;
		    ReloadTrigger->reload_mods_if_updated;
		}
	       )->install;
	    return undef;
	}
    }
    return $msg;
}

1;
=pod
info: confե⥸塼ιɤ륳ޥɤɲä롣
default: on

# ɤ¹Ԥ륳ޥ̾άȥޥɤɲäޤ
# 㤨"load"ꤹȡ"/load"ȯ褦Ȥ˥ɤ¹Ԥޤ
# λޥɤTiarra٤ΤǡIRCץȥ줿
# ޥ̾ꤹ٤ǤϤޤ
command: load

# confեɤȤΤޤ
# ⥸塼꤬ѹƤϡǤˤ餺
# ⥸塼뤴Ȥɽޤ1ޤϾά줿Τޤ
conf-reloaded-notify: 1
=cut
